local HolyPower = {}
SimplisticUF:RegisterModule(HolyPower, "hpBar", SimplisticUF.L["Holy Power Bar"], true, "PALADIN")

function HolyPower:OnEnable(frame)
	if( not frame.hpBar ) then
		frame.hpBar = CreateFrame("StatusBar", nil, frame)
		frame.hpBar:SetMinMaxValues(0, 1)
		frame.hpBar:SetValue(0)
		frame.hpBar.runes = {}

		for id=1, 3 do
			local rune = SimplisticUF.Units:CreateBar(frame.hpBar)
			rune:SetFrameLevel(1)
			rune:SetMinMaxValues(0, 1)

			if( id > 1 ) then
				rune:SetPoint("TOPLEFT", frame.hpBar.runes[id - 1], "TOPRIGHT", 1, 0)
			else
				rune:SetPoint("TOPLEFT", frame.hpBar, "TOPLEFT", 0, 0)
			end

			frame.hpBar.runes[id] = rune
		end
	else
		for _, rune in pairs(frame.hpBar.runes) do
			rune:Show()
		end
	end
	frame:RegisterNormalEvent("UNIT_POWER", self, "Update")
	frame:RegisterUpdateFunc(self, "Update")

end

function HolyPower:OnDisable(frame)
	frame:UnregisterAll(self)
end

function HolyPower:OnLayoutApplied(frame)
	if( frame.visibility.hpBar ) then
		local barWidth = (frame.hpBar:GetWidth() - 2) / 3

		for id, rune in pairs(frame.hpBar.runes) do
			if( SimplisticUF.db.profile.units[frame.unitType].hpBar.background ) then
				rune.background:Show()
			else
				rune.background:Hide()
			end

			rune.background:SetTexture(SimplisticUF.Layout.mediaPath.statusbar)
			rune.background:SetHorizTile(false)
			rune.background:SetVertexColor(1, 1, 0, SimplisticUF.db.profile.bars.backgroundAlpha)
			rune:SetStatusBarTexture(SimplisticUF.Layout.mediaPath.statusbar)
			rune:GetStatusBarTexture():SetHorizTile(false)
			rune:SetHeight(frame.hpBar:GetHeight())
			rune:SetWidth(barWidth)
			rune:SetStatusBarColor(1, 1, 0, SimplisticUF.db.profile.bars.alpha)
		end
		self:Update(frame, nil, nil, "HOLY_POWER")
	end
end

-- Updates the timers on runes
function HolyPower:Update(frame, event, _, id)
	if ( id == "HOLY_POWER" ) then
		local holyPower = UnitPower( "player", SPELL_POWER_HOLY_POWER )
		for id=1, 3 do
			if ( id <= holyPower ) then
				frame.hpBar.runes[id]:SetValue(1)
			else
				frame.hpBar.runes[id]:SetValue(0)
			end
		end
	end
end
